local _, core = ...;

local MainFrame = CreateFrame("Frame", "BijouCoinCounter", UIParent, "PortraitFrameTemplate");
local Entries = {};
local order = "name";

local function CreateCollumnButton(name, width, xOffset)
	local button = CreateFrame("Button", nil, MainFrame, "ColumnDisplayButtonTemplate");
	button:SetText(name);
	button:SetSize(width, 24);
	button:SetPoint("TOPLEFT", MainFrame, "TOPLEFT", xOffset, -56);
	return button;
end

local function CreateButton(position, yOffset)
	local button = CreateFrame("Button", nil, MainFrame, "UIPanelButtonTemplate");
	button:SetPoint("TOPLEFT", MainFrame.InsetFrame, "TOPLEFT", 290, yOffset);
	button:SetSize(60, 20);
	button:SetText("Handeln");
	return button;
end

local function CreateText(name, xOffset, yOffset)
	local text = MainFrame.InsetFrame:CreateFontString(nil, "FOREGROUND", "GameFontNormalSmall");
	text:SetPoint("TOPLEFT", MainFrame.InsetFrame, "TOPLEFT", xOffset, yOffset);
	text:SetText(name);
	return text;
end

local function clearEntry(i)
	Entries[i].name:SetText("");
	Entries[i].roll:SetText("");
	Entries[i].bijous:SetText("");
	Entries[i].coins:SetText("");
end

local function ResetTable()
	for i = 1, #Entries, 1 do
		clearEntry(i);
	end
	core:Reset();
end

local function Trade(playerName)
	print(UnitName("target"));
	InitiateTrade(playerName);
end

local function createEntry(position, row)
	Entries[position] = {};
	Entries[position].name = CreateText(row.name, 14, -position * 19 + 9);
	Entries[position].roll = CreateText(row.roll, 95, -position * 19 + 9);
	Entries[position].bijous = CreateText(row.bijous, 146, -position * 19 + 9);
	Entries[position].coins = CreateText(row.coins, 242, -position * 19 + 9);
	Entries[position].trade = CreateButton(position, -position * 19 + 15);
	local TradeObject = {};
	TradeObject.name = row.name;
	TradeObject.Trade = function()
		TradeObject:Run();
	end
	function TradeObject:Run()
		InitiateTrade(self.name);
	end;
	Entries[position].trade:SetScript("OnClick", TradeObject.Trade);
	Entries[position] = Entries[position];
end

local function fillTable(tab)
	for i = 1, #tab, 1 do
		if (#Entries >= i) then
			Entries[i].name:SetText(tab[i].name);
			Entries[i].roll:SetText(tab[i].roll);
			Entries[i].bijous:SetText(tab[i].bijous);
			Entries[i].coins:SetText(tab[i].coins);
			local TradeObject = {};
			TradeObject.name = tab[i].name;
			TradeObject.Trade = function()
				TradeObject:Run();
			end
			function TradeObject:Run()
				InitiateTrade(self.name);
			end;
			Entries[i].trade:SetScript("OnClick", TradeObject.Trade);
		else
			createEntry(i, tab[i]);
		end
	end
	if (#tab < #Entries) then
		for i = #tab + 1, #Entries, 1 do
			clearEntry(i);
		end
	end
end

local function OrderByName()
end

local function OrderByRoll()
end

local function OrderByBijous()
end

local function OrderByCoins()
end

function core:initFrame()
	MainFrame:Hide();
	MainFrame:SetSize(357, 477);
	MainFrame:SetPoint("CENTER", UIParent, "CENTER");
	MainFrame:EnableMouse(true);
	MainFrame:SetMovable(true);
	MainFrame:SetClampedToScreen(true);
	MainFrame:RegisterForDrag("LeftButton");
	MainFrame:SetScript("OnDragStart", MainFrame.StartMoving);
	MainFrame:SetScript("OnDragStop", MainFrame.StopMovingOrSizing);
	MainFrame.title = MainFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	MainFrame.title:SetPoint("CENTER", MainFrame.TitleBg, "CENTER", 0, 0);
	MainFrame.title:SetText("BijouCoinCounter");
	MainFrame.show = function(Table)
		if (not core.shown) then
			fillTable(Table);
			MainFrame:Show();
			core.shown = true;
		end
	end
	MainFrame.hide = function()
		if (core.shown) then
			MainFrame:Hide();
			core.shown = false;
		end
	end
	MainFrame.CloseButton:SetScript("OnClick", MainFrame.hide);
	MainFrame:SetScript("OnHide", function(self)
		if (self.isMoving) then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
	end);
	
	core.active = false;
	
	MainFrame.NameButton = CreateCollumnButton("Name", 83, 5);
	MainFrame.NameButton:SetScript("OnClick", OrderByName);
	MainFrame.ResultButton = CreateCollumnButton("Wurf", 53, 86);
	MainFrame.ResultButton:SetScript("OnClick", OrderByRoll);
	MainFrame.BijouButton = CreateCollumnButton("Schmuckstücke", 98, 137);
	MainFrame.BijouButton:SetScript("OnClick", OrderByBijous);
	MainFrame.CoinButton = CreateCollumnButton("Münzen", 58, 233);
	MainFrame.CoinButton:SetScript("OnClick", OrderByCoins);
	MainFrame.InsetFrame = CreateFrame("Frame", nil, MainFrame, "InsetFrameTemplate");
	MainFrame.InsetFrame:SetSize(292, 390);
	MainFrame.InsetFrame:SetPoint("TOPLEFT", MainFrame, "TOPLEFT", 3, -80);
	MainFrame.Icon = MainFrame:CreateTexture(nil, "FOREGROUND");
	MainFrame.Icon:SetPoint("TOPLEFT",-5,5);
	MainFrame.Icon:SetSize(60,60);
	--local _, _, _, _, icon = GetItemInfoInstant(19709);
	MainFrame.Icon:SetTexture("Interface\\AddOns\\BijouCoinCounter\\Hakkar.blp");
	--SetPortraitTexture(MainFrame.Icon, "player")
	return MainFrame;
end